package com.kmcx.travel.utils;

import android.os.Build;

import androidx.annotation.RequiresApi;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;

import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.util.Base64;
import java.util.Base64.Decoder;
import java.util.Base64.Encoder;

import javax.crypto.Cipher;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESedeKeySpec;
import javax.crypto.spec.IvParameterSpec;


/**
 * @author Administrator
 */
@RequiresApi(api = Build.VERSION_CODES.O)
public class DESXcrypt {

	private Cipher cipherenc = Cipher.getInstance("desede" + "/CBC/PKCS5Padding");
	private Cipher cipherdec = Cipher.getInstance("desede" + "/CBC/PKCS5Padding");
	private Decoder decoder = Base64.getDecoder();
	private Encoder encoder = Base64.getEncoder();

	public DESXcrypt(String key,String iv) throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, InvalidAlgorithmParameterException {
		byte[] keys = decoder.decode(key);
		byte[] keyiv = decoder.decode(iv);

		DESedeKeySpec spec = new DESedeKeySpec(keys);
		SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("desede");
		Key deskey  = keyfactory.generateSecret(spec);

		IvParameterSpec ips = new IvParameterSpec(keyiv);

		cipherenc.init(Cipher.ENCRYPT_MODE, deskey, ips);
		cipherdec.init(Cipher.DECRYPT_MODE, deskey, ips);
	}
	/**
	 /**
	 * CBC加密
	 * @param key 密钥
	 * @param keyiv IV
	 * @param data 明文
	 * @return Base64编码的密文
	 * @throws Exception
	 */
	public String encode(String data)
			throws Exception {
		byte[] bOut = this.cipherenc.doFinal(data.getBytes("UTF-8"));
		return this.encoder.encodeToString(bOut);
	}

	/**
	 * CBC解密
	 * @param key 密钥
	 * @param keyiv IV
	 * @param data Base64编码的密文
	 * @return 明文
	 * @throws Exception
	 */
	public String decode(String data)
			throws Exception {
		byte[] bOut = this.cipherdec.doFinal(this.decoder.decode(data));

		return new String(bOut, "UTF-8");
	}
}
