;
(function(root, factory, undef) {
  if (typeof exports === "object") {
    // CommonJS
    module.exports = exports = factory(require("./core"),
      require("./enc-base64.js"),
      require("./enc-utf8.js"),
      require("./cipher-core.js"),
      require("./tripledes.js"));
  } else if (typeof define === "function" && define.amd) {
    // AMD
    define(["./core.js", "./enc-base64.js", "./enc-utf8.js", "./cipher-core.js", "./tripledes.js"], factory);
  } else {
    // Global (browser)
    factory(root.CryptoJS);
  }
}(this, function(CryptoJS) {
  (function() {
    CryptoJS.baibing = {
      //need core.js/enc-utf8.js/enc-base64.js/cipher-core.js/tripledes.js
      encrypt: function(val, key, iv) {
        return CryptoJS.TripleDES.encrypt(CryptoJS.enc.Utf8.parse(val), CryptoJS.enc.Base64.parse(key), {
          iv: CryptoJS.enc.Base64.parse(iv),
          mode: CryptoJS.mode.CBC,
          padding: CryptoJS.pad.Pkcs7
        }).toString();
      },
      decrypt: function(val, key, iv) {
        return CryptoJS.TripleDES.decrypt(val, CryptoJS.enc.Base64.parse(key), {
          iv: CryptoJS.enc.Base64.parse(iv),
          mode: CryptoJS.mode.CBC,
          padding: CryptoJS.pad.Pkcs7
        }).toString(CryptoJS.enc.Utf8);
      }
    };
  })();
  return CryptoJS.baibing;
}));