const config = require('./config.js');
const Buffer = require('./libs/Buffer').Buffer
const {
  encrypt,
  decrypt
} = require('./cryptojs/3des.js');

const formatNumber = n => {

  n = n.toString()

  return n[1] ? n : '0' + n

}
/* 计算两日期相差的日期年月日等 new Date().diff('h',new Date().add('d',1)); */
Date.prototype.diff = function(interval, objDate2) {
  var d = this,
    i = {},
    t = d.getTime(),
    t2 = objDate2.getTime();
  i['y'] = objDate2.getFullYear() - d.getFullYear();
  i['q'] = i['y'] * 4 + Math.floor(objDate2.getMonth() / 4) - Math.floor(d.getMonth() / 4);
  i['m'] = i['y'] * 12 + objDate2.getMonth() - d.getMonth();
  i['ms'] = objDate2.getTime() - d.getTime();
  // i['w'] = Math.floor((t2 + 345600000) / (604800000)) - Math.floor((t + 345600000) / (604800000));
  // i['d'] = Math.floor(t2 / 86400000) - Math.floor(t / 86400000);
  // i['h'] = Math.floor(t2 / 3600000) - Math.floor(t / 3600000);
  // i['n'] = Math.floor(t2 / 60000) - Math.floor(t / 60000);
  // i['s'] = Math.floor(t2 / 1000) - Math.floor(t / 1000);
  i['w'] = Math.floor((t2 - t) / (604800000.0));
  i['d'] = Math.floor((t2 - t) / 86400000.0);
  i['h'] = Math.floor((t2 - t) / 3600000.0);
  i['n'] = Math.floor((t2 - t) / 60000.0);
  i['s'] = Math.floor((t2 - t) / 1000.0);
  return i[interval];
}
/* 计算两日期相差的日期年月日等 new Date().diff('h',new Date().add('d',1)); */
Date.prototype.sub = function(interval, objDate2) {
  return Date.prototype.diff.apply(objDate2, [interval, this]);
}

/* 格式化日期 1537578367970.format('yyyy-MM-dd')); */
Number.prototype.format = function(format) {

  if (!format) {
    format = "yyyy-MM-dd hh:mm:ss";
  }

  var date = new Date(this);

  var o = {
    "M+": date.getMonth() + 1, // month
    "d+": date.getDate(), // day
    "h+": date.getHours(), // hour
    "m+": date.getMinutes(), // minute
    "s+": date.getSeconds(), // second
    "q+": Math.floor((date.getMonth() + 3) / 3), // quarter
    "S": date.getMilliseconds()
    // millisecond
  }
  if (/(y+)/.test(format)) {
    format = format.replace(RegExp.$1, (date.getFullYear() + "")
      .substr(4 - RegExp.$1.length));
  }

  for (var k in o) {
    if (new RegExp("(" + k + ")").test(format)) {
      format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] :
        ("00" + o[k]).substr(("" + o[k]).length));
    }
  }
  return format;
}

var _getType = function(x) {
  if (x == null) {
    return "null";
  }
  var t = typeof x;
  if (t != "object" && t != 'Object') {
    return t;
  }
  if (Object.prototype.toString.call(x) === '[object Array]') {
    return 'Array';
  }
  var c = Object.prototype.toString.apply(x);
  c = c.substring(8, c.length - 1);
  if (c != "Object") {
    return c;
  }
  if (x.constructor == Object) {
    return c;
  }
  if (x.prototype && "classname" in x.prototype.constructor &&
    typeof x.prototype.constructor.classname == "string") {
    return x.constructor.prototype.classname;
  }
  return "ukObject";
};
var _clone = function(source) {
  switch (_getType(source)) {
    case 'Object':
    case 'object':
    case 'ukObject':
      return _merge({}, source);
    case 'array':
    case 'Array':
      var aim = [];
      for (var i in source) {
        aim.push(_clone(source[i]));
      }
      return aim;
    default:
      return source;
  }
};
var _merge = function(aim, source) {
  if (aim == undefined) return _clone(source);
  switch (_getType(source)) {
    case 'Array':
      //处理数组
      var hasmergeIndex = false;
      for (var i3 = 0, k = source[i3]; i3 < source.length; i3++, k = source[i3]) {
        if (k === null || k === undefined) continue;
        if (typeof(k.mergeIndex) == "number") {
          hasmergeIndex = true;
          if (aim.length < (k.mergeIndex + 1)) {
            aim[aim.length] = k;
          } else {
            aim[i3] = _merge(aim[i3], k);
          }
        } else if (typeof(k.moveIndex) == "number") {
          hasmergeIndex = true;
          aim.splice(k.moveIndex, 0, k);
        }
      }
      if (!hasmergeIndex) {
        aim = _clone(source);
      }
      return aim;
    case 'object':
    case 'Object':
    case 'ukObject':
      if (typeof(aim) == 'string') return source;
      else {
        for (var i in source)
          aim[i] = _merge(aim[i], source[i]);
        return aim;
      }
      break;
    case 'null':
      return (source === undefined) ? aim : source;
    default:
      return source;
  }
};

const atob = (str) => new Buffer(str, 'base64').toString('binary')

const btoa = (str) => {
  var buffer
  if (str instanceof Buffer) {
    buffer = str
  } else {
    buffer = new Buffer(str.toString(), 'binary')
  }
  return buffer.toString('base64')
}

var index = 0;
const ret = {
  encodeEmoji: str => (
    btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, (match, p1) => String.fromCharCode('0x' + p1)))
  ),
  decodeEmoji: str => {
    var ret
    try {
      ret = decodeURIComponent(atob(str).split('').map((c) => '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2)).join(''))
    } catch (e) {
      ret = decodeURIComponent(str)
    }
    return ret || str
  },
  formatTime: date => {
    const year = date.getFullYear()
    const month = date.getMonth() + 1
    const day = date.getDate()
    const hour = date.getHours()
    const minute = date.getMinutes()
    const second = date.getSeconds()

    return [year, month, day].map(formatNumber).join('/') + ' ' + [hour, minute, second].map(formatNumber).join(':')
  },
  formatNumber: n => {
    n = n.toString()
    return n[1] ? n : '0' + n
  },
  merge: function() {
    var argu = arguments;
    if (argu.length < 2) {
      return argu[0] ? argu[0] : {}
    };
    if (argu.length > 0 && true == argu[argu.length - 1]) {
      var _ = argu[0];
      for (var i2 = 1; i2 < argu.length - 1; i2++)
        _ = _merge(_, argu[i2]);
      return _;
    } else {
      var _ = {};
      for (var i2 = 0; i2 < argu.length; i2++)
        _ = _merge(_, argu[i2]);
      return _;
    }
  },
  post: function(method, paras = {}, sessionID) {
    const url = config.Method[method.toLowerCase()] || method;
    if (method.toLowerCase() == 'login') {
      paras = {
        projectid: config.ProjectID,
        token: encrypt(JSON.stringify(ret.merge({
          time: new Date().getTime()
        }, paras)), config.PWD.Key, config.PWD.IV)
      };
    } else if (config.PWD.isEncryptData) {
      console.log('加密发送', paras);
      paras = {
        _data: encrypt(JSON.stringify(ret.merge({
          time: new Date().getTime()
        }, paras)), config.PWD.Key, config.PWD.IV),
        sessionID: sessionID || config.sessionID || ''
      };
    } else paras.sessionID = sessionID || config.sessionID || '';
    return new Promise(function(success, fail) {
      wx.request({
        url,
        data: paras,
        method: 'POST',
        success: res => {
          config.debugMode && console.warn('请求地址: ', url) || console.warn('发送参数: ', paras) || console.warn('返回结果: ', res)
          if (res.data.error) fail(new Error(res.data.error))
          else {
            success({
              data: res.data,
              head: res.header
            });
          }

        },
        fail
      });
    });
  },
  onError: (
    content = '服务器繁忙，请稍后再试！',
    title = '错误提示'
  ) => {

    // var err = new Error('新错误')
    // throw err

    var errMsg = "错误信息为：======="+ content;

    console.info(errMsg);

    //上传错误日志
    ret.post('loginfo', {
        source: "小程序",
        Descs: content,
        Type: 1
      })
      .then(function(res) {

      }).catch(
        e => {
          console.info("logininfo接口异常 " + e.message)
        }
      )
    // wx.showModal({
    //   title,
    //   content,
    //   showCancel: false,
    // })
  },
  goBack: (delta = 1) => wx.navigateBack({
    delta
  }),
  onShareAppMessage: ({
    title = '金信融诚',
    path = '/pages/home/home',
    success = () => {},
    fail = () => {},
  } = {}) => ({
    title,
    path,
    success,
    fail,
  }),
  ok: (text) => wx.showModal({
    showCancel: false,
    confirmColor: 'green',
    content: text,
  }),
  isValid: v => !!v && !!(v + '').length,
  uploadfile: (v, name) => new Promise(function(rp, rj) {
    /**
     * 上传完成后把文件上传到服务器
     */
    //上传文件
    wx.uploadFile({
      url: 'https://add-jxrc.oss-cn-beijing.aliyuncs.com',
      filePath: v,
      name: 'file',
      header: {
        "Content-Type": "multipart/form-data"
      },
      formData: {
        name: v,
        key: name,
        policy: 'eyJleHBpcmF0aW9uIjoiMjAyMC0wMS0wMVQxMjowMDowMC4wMDBaIiwiY29uZGl0aW9ucyI6W1siY29udGVudC1sZW5ndGgtcmFuZ2UiLDAsMTA0ODU3NjAwMF1dfQ==',
        OSSAccessKeyId: 'LTAIzPrmLrpFzgF7',
        'success_action_status': '200',
        'signature': 'bF68VKAfqCNXZycZsr5+BrRolmI='
      },
      success: function(res) {
        console.log('upload', v, name, res);
        if (res.statusCode == 200) rp('https://add-jxrc.oss-cn-beijing.aliyuncs.com/' + name);
        else rj(new Error(res.statusCode));
      },
      fail: rj
    });
  }),
  random: function() {
    return parseInt('' + (new Date()).getTime() + (index++));
  }
}
module.exports = ret;